#include<iostream>
using namespace std;
const long long mod=998244353;
int main () {
    long long n,m,k;
    cin>>n>>m>>k;
    long long ans=1;
    if(k==1){
        for(int i=1;i<=n;i++){
            ans*=m;
            ans%=mod;
        }
    }if(k==2){
        n-=2;
        ans*=m*m;
        ans%=mod;
        for(int i=1;i<=n;i++){
            ans*=2;
            ans%=mod;
        }
        ans-=m;
    }
    cout<<ans<<"\n";
    return 0;
}
